/*
	includes Eigen and declares basic types
*/

#ifndef __EIGEN_INCLUDE_H
#define __EIGEN_INCLUDE_H

#include <Eigen/Core>
#include <Eigen/Sparse>
#include <Eigen/Geometry>
#include <Eigen/StdVector>

typedef double	ScalarType;
typedef int		IndexType;

typedef Eigen::Matrix<ScalarType, Eigen::Dynamic, 3, Eigen::RowMajor> PointMatrixType;
typedef Eigen::Matrix<IndexType,  Eigen::Dynamic, 3, Eigen::RowMajor> FaceMatrixType;

typedef Eigen::Matrix<ScalarType, Eigen::Dynamic, Eigen::Dynamic>	MatrixXX;
typedef Eigen::Matrix<ScalarType, Eigen::Dynamic, 1>				VectorX;
typedef Eigen::Matrix<ScalarType, 1,              Eigen::Dynamic>	RowVectorX;
typedef Eigen::Matrix<ScalarType, 1,              3>				RowVector3;
typedef Eigen::Matrix<IndexType,  1,              3>				RowVector3i;
typedef Eigen::Matrix<IndexType,  Eigen::Dynamic, 8>		        MatrixX8i;
typedef Eigen::Matrix<IndexType,  Eigen::Dynamic, 6>			    MatrixX6i;

typedef Eigen::SparseMatrix<ScalarType> SparseMatrix;
typedef Eigen::Triplet<ScalarType,IndexType> SparseMatrixTriplet;

#endif

