#ifndef __HANDLES_H
#define __HANDLES_H

#include "../STL_inc.h"
#include "../EIGEN_inc.h"

// class to store the list of handles
// an handle is a point in 3D and the corresponding index in the voxel grid (needed to built the QP system)
class Handles {

private:
	vector<RowVector3> m_positions; // 3D position
	vector<int> m_nodes; // index of the corresponding voxel grid node

public:
	Handles() {}
	~Handles() {}

	void addHandle(const RowVector3 & position, const int node) {
		m_nodes.push_back(node);
		m_positions.push_back(position);
	}

	int getNumHandles() const { return m_nodes.size(); }

	const RowVector3 & getHandlePose(int j) const { return m_positions[j]; }
	int getConstraint(int j) const { return m_nodes[j]; }

};

#endif