#ifndef __WEIGHTS_H
#define __WEIGHTS_H

#include "../STL_inc.h"
#include "../EIGEN_inc.h"

// simple class to store the weights
class Weights {

private:
	vector<ScalarType> m_coords; 
	ScalarType m_sumCoords;
	
public:
	Weights() {
		m_sumCoords = 0;
	}
	~Weights() {}

	void pushWeight(ScalarType w) {
		m_coords.push_back(w);
		m_sumCoords += w;
	}

	ScalarType getCoord(int idHandle) const { return m_coords[idHandle]; }

	void normalizeWeights() {
		for(unsigned int i = 0; i < m_coords.size(); i++) {
			m_coords[i] /= m_sumCoords;
		}
		m_sumCoords = 1.0;
	}

};

#endif