#include "VoxelBBW.h"

#include "voxelizer\OPENGL_inc.h"

int main(int argc, char *argv[])
{
	// Initialize GLUT for the voxelizer
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_MULTISAMPLE);
	glutCreateWindow("");

	cout << "-----------------------------------------------" << endl;
	cout << endl;
	cout << "Voxel BBW (June 2013)" << endl;
	cout << endl;
	cout << "Romain Prevost" << endl;
	cout << "rprevost@inf.ethz.ch" << endl;
	cout << endl;
	cout << "-----------------------------------------------" << endl;
	cout << "This program compute bounded biharmonic weights for a mesh using a voxel grid." << endl;
	cout << endl;
	cout << "It requires:" << endl;
	cout << "- a fairly recent Nvidia graphics card with an up-to-date driver (version >= 310 I think) for the voxelizer" << endl;
	cout << "- Mosek library for the QP solver." << endl;
	cout << endl;
	cout << "Please contact me if any trouble. The source code is also available online." << endl;
	cout << endl << endl;

	string meshfile;
	cout << "Meshfile: ";
	cin >> meshfile;

	VoxelBBW::openMesh(meshfile);
	
	int voxRes;
	cout << "Resolution: ";
	cin >> voxRes;

	VoxelBBW::computeVoxelGrid(voxRes);
	
	vector<RowVector3> handles;
	int N = 0;
	RowVector3 P;
	cout << "# handles: ";
	cin >> N;
	for(int i = 0 ; i < N ; ++i) {
		cout << "Handle " << i << " (x,y,z):" << endl;
		cin >> P[0] >> P[1] >> P[2];
		handles.push_back(P);
	}
	
	VoxelBBW::computeBBW(handles);
	
	cout << "How do you want to export the results?" << endl;
	cout << "1. Single file" << endl;
	cout << "2. One file per handle" << endl;
	int choice;
	cin >> choice;
	if(choice == 1)
		VoxelBBW::exportBBW(meshfile,true);
	else
		VoxelBBW::exportBBW(meshfile,false);


	return 0;
}



